program Sinusgenerator;
uses Crt, RS232, PLL;

var Frequenz    : Real;
    Teiler, N   : Integer;

procedure SinusLaden;
var Spannung : Byte;    N : Integer;
begin
  BusOut (67, 128);              { 8255, A,C,C out      }
  BusOut (66, 128);              { C7, Zhler-Reset     }
  BusOut (66, 0);
  for N := 0 to 25 do begin
    Spannung := Lo ( round ( 127.5 + 127.5 * sin (N / 25 * 2 * Pi )));
    BusOut (65, Spannung);
  end;
  BusOut (64, 1);                { Adresse 128          }
  BusOut (66, 128);
  BusOut (66, 0);
  for N := 0 to 250 do begin
    Spannung := Lo ( round ( 127.5 + 127.5 * sin (N / 250 * 2 * Pi )));
    BusOut (65, Spannung);
  end;
  BusOut (64, 4);                { Adresse 512          }
  BusOut (66, 128);
  BusOut (66, 0);
  for N := 0 to 2500 do begin
    Spannung := Lo ( round ( 127.5 + 127.5 * sin (N / 2500 * 2 * Pi )));
    BusOut (65, Spannung);
  end;
  BusOut (67, 130);
  BusOut (66, 36);               { Speicher Ausgabe    }
end;

procedure Ausgabe (Frequenz : Real);
var
  Abtastrate          :  Real;
  Punkte              :  Integer;
  Low, High, Teiler   :  Byte;
  Bereich, Bereichalt :  Byte;
begin
  Abtastrate := Frequenz * 0.025;
  Bereich := 0;
  Punkte := 50;
  if Frequenz < 2000 then begin
    Bereich := 1;
    Abtastrate := Frequenz * 0.25;
    Punkte := 500;
 end;
  if Frequenz < 200 then begin
    Bereich := 4;
    Abtastrate := Frequenz * 2.5;
    Punkte := 5000;
  end;
  BusIn (64, BereichAlt);
  if BereichAlt <> Bereich then begin
  BusOut (64, Bereich);
    BusOut (71, 54);
    BusOut (71, 116);
    BusOut (71, 180);
    BusOut (68, 4);
    BusOut (68, 0);
    BusOut (69, 2);
    BusOut (69, 0);
    High := Hi (Punkte);
    Low := LO (Punkte);
    BusOut (70, Low);
    BusOut (70, High);
    BusOut (72, 0);
  end;
  Abtastrate := Abtastrate * 2;
  Einstellen (Abtastrate);
end;


begin
  SinusLaden;           
  PLL_Init;
  Frequenz := 1;
  repeat
    write ('Ausgangsfrequenz in Hz ');
    readln (Frequenz);
    Ausgabe (Frequenz);
  until Frequenz < 1 ;
end.

{ Alternatives Hauptprogramm } 
begin
  SinusLaden;           
  PLL_Init;
  Einstellen (500);
  delay (2000);
    N := 0;
  repeat
    Frequenz := 500 + 300* sin (n/300);
    Einstellen (Frequenz);
    N := N+1;
  until KeyPressed;
end.
