program Diagramme;
uses Crt, Graph, Daten;
var   Ch                :   Char;
      xres, Yres, Zeit  : Integer;

procedure GrafikInit;
var Graphdriver, Graphmode, Graphcode : Integer;
begin
  graphDriver := Detect;
  InitGraph (Graphdriver, Graphmode, '');
  xres := GetmaxX; Yres := GetmaxY;
end;

function wx (x: Integer): Integer;
 begin
   wx :=  round (x * (xres/1000));
 end;

function wy (y: Integer): Integer;
 begin
   wy :=  round ((1000-y)*(yres/1000));
 end;

procedure DiagrammInit;
var i, j : Integer;
     Zahl    : String;
begin
   Grafikinit;
   Line (wx(100),wy(100),wx(900),wy(100));
   Line (wx(900),wy(100),wx(900),wy(868));
   Line (wx(900),wy(868),wx(100),wy(868));
   Line (wx(100),wy(868),wx(100),wy(100));
   SetLineStyle (1,2,1);
   for i := 1 to 10 do
     Line (wx(100),wy(100+75*i),wx(900),wy(100+75*i));
   SetTextJustify (2,1);
   for i := 0 to 10 do
     begin
       Str (0.25*i:2:2,Zahl);
       Zahl := concat (Zahl, ' V');
       OutTextXY (wx(90),wy(100+75*i),Zahl);
     end;
   for i := 1 to 10 do
     Line (wx(100+80*i),wy(100),wx(100+80*i),wy(868));
   SetTextJustify (1,1);
   for i := 0 to 10 do
     begin
       Str (100*i,Zahl);
       OutTextXY (wx(100+80*i),wy(70),Zahl);
     end;
end;

procedure Plot (Kanal : Integer);
var i : Integer;
    Stepweite : real;
begin
  SetLineStyle (0,2,1);
  moveto (wx(100),wy(100+3*Puffer[Kanal]));
  for i := 0 to 999 do
    lineto (wx(100+round(i*0.8)),wy (100+3*Puffer[i*4+Kanal]));
end;

begin
  Oeffnen9600;
  ClrScr;
  writeln ('Bitte Intervallzeit in ms eingeben ');
  readln (Zeit);
  Init4Kanal (1000,Zeit);
  Start;
  Writeln ('Bitte Taste drcken, wenn Messung beendet');
  Repeat until KeyPressed; Ch := ReadKey;
  Writeln ('Bitte warten');
  Einlesen (4000);
  DiagrammInit;
  repeat;
    repeat until KeyPressed;
    Ch := ReadKey;
      If Ch in ['1'..'4'] then Plot (ord(Ch)-48);
  until Ch = chr (27);
  CloseGraph;
end.
